BEGIN;

CREATE TABLE public.annotation
(
  id VARCHAR(255) NOT NULL,
  "version" VARCHAR(255) NOT NULL,
  target_id VARCHAR(255),
  state VARCHAR(255),
  visibility VARCHAR(255),
  "type" VARCHAR(255),
  edition_date timestamp without time zone,
  editor_user_id VARCHAR(255),
  change_reason VARCHAR(255),
  top_target_id VARCHAR(255),
  creation_date timestamp without time zone,
  creator_user_id character varying(255),
  CONSTRAINT annotation_pkey PRIMARY KEY (id, version)
);

CREATE TABLE public.annotation_atachment_ids
(
  id VARCHAR(255) NOT NULL,
  "version" VARCHAR(255) NOT NULL,
  atachment_id VARCHAR(255),
  "index" integer NOT NULL,
  CONSTRAINT annotation_atachment_ids_pkey PRIMARY KEY (id, version, index),
  CONSTRAINT fkbf28f3bad7efc541 FOREIGN KEY (id, "version")
      REFERENCES annotation (id, "version") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE public.annotation_atachments
(
  id VARCHAR(255) NOT NULL,
  "content" bytea,
  CONSTRAINT annotation_atachments_pkey PRIMARY KEY (id)
);


CREATE TABLE public.annotation_body
(
  id VARCHAR(255) NOT NULL,
  "version" VARCHAR(255) NOT NULL,
  "content" VARCHAR(255),
  "type" VARCHAR(255),
  CONSTRAINT annotation_body_pkey PRIMARY KEY (id, version),
  CONSTRAINT fk330bd8b2d7efc541 FOREIGN KEY (id, "version")
      REFERENCES annotation (id, "version") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE public.annotation_tags
(
  id VARCHAR(255) NOT NULL,
  "version" VARCHAR(255) NOT NULL,
  tag VARCHAR(255),
  "index" integer NOT NULL,
  CONSTRAINT annotation_tags_pkey PRIMARY KEY (id, version, index),
  CONSTRAINT fk6e8fa729d7efc541 FOREIGN KEY (id, "version")
      REFERENCES annotation (id, "version") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

COMMIT;