CREATE TABLE meta_browseversion (version VARCHAR(32));
-- split
INSERT INTO meta_browseversion VALUES ('1.04');
-- split
DROP TABLE IF EXISTS meta_fields;
-- split
DROP TABLE IF EXISTS meta_views;
-- split
DROP TABLE IF EXISTS meta_lastmods;
-- split
DROP TABLE IF EXISTS meta_relations;
-- split
CREATE TABLE meta_relations (
	pk	integer		PRIMARY KEY,
	name	varchar(32)	NOT NULL,
	version	integer		NOT NULL,
	is_aggr_enabled boolean default true,
	tags	varchar(1024),
	
	UNIQUE (name, version)
);
-- split
CREATE TABLE meta_fields (
	fk		integer		NOT NULL REFERENCES meta_relations, -- ON DELETE CASCADE => TRIGGER
	pos		integer		NOT NULL,
	name		varchar(32)	NOT NULL,
	type		varchar(32)	NOT NULL,
	is_dict		boolean		NOT NULL,
	is_indexed	boolean		NOT NULL,

	PRIMARY KEY	(fk, pos),
	UNIQUE (fk, name)
);
-- split
CREATE TABLE meta_views (
    uuid            VARCHAR(36)     PRIMARY KEY,
    relation        BIGINT          NOT NULL REFERENCES meta_relations, -- ON DELETE CASCADE => TRIGGER
    groupingfields  VARCHAR(1024)   NOT NULL,
    indexedfields  VARCHAR(1024),
    agntype         CHAR(3)         NOT NULL DEFAULT 'CNT',
    agnfield        VARCHAR(32),
    condition       TEXT,
    ordered         INTEGER,
    mattype         CHAR(4)         NOT NULL DEFAULT 'NONE',
    name			VARCHAR(128)
);
-- split
CREATE TABLE meta_lastmods (
    name            VARCHAR(64)     PRIMARY KEY,
    stamp           TIMESTAMP,
    rebuild			BOOLEAN NOT NULL DEFAULT FALSE
);
-- split
CREATE TRIGGER meta_fields_fk_on_delete_cascade BEFORE DELETE ON meta_relations
FOR EACH ROW BEGIN
	DELETE FROM meta_fields WHERE fk = OLD.pk;
END;
-- split
CREATE TRIGGER meta_views_fk_on_delete_cascade BEFORE DELETE ON meta_views
FOR EACH ROW BEGIN
	DELETE FROM meta_views WHERE relation = OLD.pk;
END;
