----
-- Catalog sql init script for PostgreSQL
----

CREATE SEQUENCE /* TABLE_PREFIX */ OBJECT_METADATA__ID_SEQ;

CREATE TABLE /* TABLE_PREFIX */ OBJECT_METADATA (
	_ID			BIGINT					PRIMARY KEY	DEFAULT nextval(/* TABLE_PREFIX */ 'OBJECT_METADATA__ID_SEQ'),
	_HISTORY	BOOLEAN					NOT NULL	DEFAULT FALSE,
	ID			CHARACTER VARYING(512)	NOT NULL,
	BRANCH		CHARACTER VARYING(256)	NOT NULL,
	VERSION		CHARACTER VARYING(256)	NOT NULL,
	STATUS		CHARACTER VARYING(32)	NOT NULL,
	TIMESTAMP	TIMESTAMP				NOT NULL,
	ALT_ID		CHARACTER VARYING(512),
	ALT_BRANCH	CHARACTER VARYING(256),
	ALT_VERSION	CHARACTER VARYING(256),

	UNIQUE (ID, BRANCH, VERSION)
);

CREATE UNIQUE INDEX /* TABLE_PREFIX */ OBJECT_METADATA_ID_CURRENT ON /* TABLE_PREFIX */ OBJECT_METADATA (ID) WHERE _HISTORY = FALSE;
CREATE INDEX /* TABLE_PREFIX */ OBJECT_METADATA_PAGING_INDEX ON /* TABLE_PREFIX */ OBJECT_METADATA (TIMESTAMP,_ID);

CREATE TABLE /* TABLE_PREFIX */ OBJECT_PARTS (
	_META_ID	BIGINT					NOT NULL	REFERENCES /* TABLE_PREFIX */ OBJECT_METADATA (_ID),
	TYPE		CHARACTER VARYING(256)	NOT NULL,
	SEARCH_KEY	CHARACTER VARYING(256),
	DATA		TEXT					NOT NULL,

	PRIMARY KEY (_META_ID, TYPE)
);

CREATE INDEX /* TABLE_PREFIX */ OBJECT_PARTS_SEARCH_INDEX ON /* TABLE_PREFIX */ OBJECT_PARTS (SEARCH_KEY);

CREATE TABLE /* TABLE_PREFIX */ METADATA_TAGS (
	TAG			TEXT	NOT NULL,
	_META_ID	BIGINT	NOT NULL	REFERENCES	/* TABLE_PREFIX */ OBJECT_METADATA (_ID),

	UNIQUE (TAG, _META_ID)
);

CREATE INDEX /* TABLE_PREFIX */ METADATA_TAGS__META_ID ON /* TABLE_PREFIX */ METADATA_TAGS (_META_ID);
