CREATE TABLE /* TABLE_PREFIX */OBJECT_METADATA (
	_ID		INTEGER			PRIMARY KEY,
	_HISTORY	BOOLEAN			NOT NULL	DEFAULT FALSE,
	ID		CHARACTER VARYING(512)	NOT NULL,
	BRANCH		CHARACTER VARYING(256)	NOT NULL,
	VERSION		CHARACTER VARYING(256)	NOT NULL,
	STATUS		CHARACTER VARYING(32)	NOT NULL,
	TIMESTAMP	TIMESTAMP		NOT NULL,
	CREATION_TIMESTAMP TIMESTAMP		NOT NULL,
	ALT_ID		CHARACTER VARYING(512),
	ALT_BRANCH	CHARACTER VARYING(256),
	ALT_VERSION	CHARACTER VARYING(256),

	UNIQUE (ID, BRANCH, VERSION)
);
-- split
CREATE INDEX /* TABLE_PREFIX */OBJECT_METADATA_TIMESTAMP_INDEX ON /* TABLE_PREFIX */OBJECT_METADATA (TIMESTAMP);
-- split
CREATE TABLE /* TABLE_PREFIX */OBJECT_PARTS (
	_META_ID	BIGINT			NOT NULL	REFERENCES /* TABLE_PREFIX */OBJECT_METADATA (_ID),
	PARTSTAMP	TIMESTAMP		NOT NULL,
	TYPE		CHARACTER VARYING(256)	NOT NULL,
	SEARCH_KEY	CHARACTER VARYING(256),
	DATA		TEXT			NOT NULL,

	PRIMARY KEY (_META_ID, TYPE)
);
-- split
CREATE INDEX /* TABLE_PREFIX */OBJECT_PARTS_TIMESTAMP_INDEX ON /* TABLE_PREFIX */OBJECT_PARTS (PARTSTAMP);
-- split
CREATE INDEX /* TABLE_PREFIX */ OBJECT_PARTS_SEARCH_INDEX ON /* TABLE_PREFIX */ OBJECT_PARTS (SEARCH_KEY);
-- split
CREATE TABLE /* TABLE_PREFIX */METADATA_TAGS (
	TAG		TEXT	NOT NULL,
	_META_ID	BIGINT	NOT NULL	REFERENCES	/* TABLE_PREFIX */OBJECT_METADATA (_ID),

	UNIQUE (TAG, _META_ID)
);
-- split
CREATE INDEX /* TABLE_PREFIX */METADATA_TAGS__META_ID ON /* TABLE_PREFIX */METADATA_TAGS (_META_ID);
-- split
CREATE TABLE /* TABLE_PREFIX */catalog_version (
    version VARCHAR(32)
);
-- split
INSERT INTO /* TABLE_PREFIX */catalog_version VALUES ('1.03');