create table public.uc_version (version varchar(255) not null, primary key (version));
insert into public.uc_version values ('1.02');
create table public.uc_credential (id varchar(255) not null, user_id varchar(255) not null, status varchar(255) not null, expire_date int8 default 0, primary key (id));
create table public.uc_credential_login_password (credential_id varchar(255) not null, password varchar(255) not null, primary key (credential_id));
create table public.uc_group (id varchar(255) not null, parent_id varchar(255), name varchar(255) not null, domain varchar(255) not null, primary key (id), unique (name, domain));
create table public.uc_group_role (group_id varchar(255) not null, role varchar(255) not null, primary key (group_id, role));
create table public.uc_group_role_effective (group_id varchar(255) not null, role varchar(255) not null, primary key (group_id, role));
create table public.uc_group_attribute (group_id varchar(255) not null, attribute_value text not null, attribute_key varchar(255) not null, primary key (group_id, attribute_key));
create table public.uc_user (id varchar(255) not null, domain varchar(255) not null, primary key (id));
create table public.uc_user_attribute (user_id varchar(255) not null, attribute_value text not null, attribute_key varchar(255) not null, primary key (user_id, attribute_key));
create table public.uc_user_flag (user_id varchar(255) not null, flag varchar(255) not null, primary key (user_id, flag));
create table public.uc_user_group (user_id varchar(255) not null, group_id varchar(255) not null, primary key (group_id, user_id));
create table public.uc_user_group_effective (user_id varchar(255) not null, group_id varchar(255) not null, primary key (group_id, user_id));
create table public.uc_user_identifier (user_id varchar(255) not null, domain varchar(255) not null, identifier varchar(255), primary key (user_id, identifier), unique (domain, identifier));
create table public.uc_user_role (user_id varchar(255) not null, role varchar(255) not null, primary key (user_id, role));
create table public.uc_user_role_effective (user_id varchar(255) not null, role varchar(255) not null, primary key (user_id, role));
create index uc_credential_fk_idx on public.uc_credential (user_id);
alter table public.uc_credential add constraint FK13B72AA898609D3F foreign key (user_id) references public.uc_user;
alter table public.uc_credential_login_password add constraint FK9A1AE1287325E1FF foreign key (credential_id) references public.uc_credential;
create index uc_group_parentid_idx on public.uc_group (parent_id);
alter table public.uc_group add constraint FK96EFC58EFE31508A foreign key (parent_id) references public.uc_group;
create index uc_group_role_fk_idx on public.uc_group_role (group_id);
alter table public.uc_group_role add constraint FK88E3BC87A0F91695 foreign key (group_id) references public.uc_group;
create index uc_group_role_effective_fk_idx on public.uc_group_role_effective (group_id);
alter table public.uc_group_role_effective add constraint FKD0BA23EFA0F91695 foreign key (group_id) references public.uc_group;
create index uc_user_domain_idx on public.uc_user (domain);
create index uc_user_attribute_idx on public.uc_user_attribute (attribute_value, attribute_key);
create index uc_user_attribute_fk_idx on public.uc_user_attribute (user_id);
alter table public.uc_user_attribute add constraint FKCFA740F998609D3F foreign key (user_id) references public.uc_user;
create index uc_user_flag_fk_idx on public.uc_user_flag (user_id);
create index uc_user_flag_idx on public.uc_user_flag (flag);
alter table public.uc_user_flag add constraint FKD41922EF98609D3F foreign key (user_id) references public.uc_user;
create index uc_user_group_fk2_idx on public.uc_user_group (group_id);
create index uc_user_group_fk1_idx on public.uc_user_group (user_id);
alter table public.uc_user_group add constraint FKAF1C435C98609D3F foreign key (user_id) references public.uc_user;
alter table public.uc_user_group add constraint FKAF1C435CA0F91695 foreign key (group_id) references public.uc_group;
create index uc_user_group_effective_fk1_idx on public.uc_user_group_effective (user_id);
create index uc_user_group_effective_fk2_idx on public.uc_user_group_effective (group_id);
alter table public.uc_user_group_effective add constraint FK28CBE48498609D3F foreign key (user_id) references public.uc_user;
alter table public.uc_user_group_effective add constraint FK28CBE484A0F91695 foreign key (group_id) references public.uc_group;
create index uc_user_identifier_fk_idx on public.uc_user_identifier (user_id);
alter table public.uc_user_identifier add constraint FKAC9BE1EC98609D3F foreign key (user_id) references public.uc_user;
create index uc_user_role_fk_idx on public.uc_user_role (user_id);
alter table public.uc_user_role add constraint FKD41EA3F998609D3F foreign key (user_id) references public.uc_user;
create index uc_user_role_effective_idx on public.uc_user_role_effective (role);
create index uc_user_role_effective_fk_idx on public.uc_user_role_effective (user_id);
alter table public.uc_user_role_effective add constraint FK8697E4E198609D3F foreign key (user_id) references public.uc_user;
create index uc_group_attribute_idx on public.uc_group_attribute (attribute_value, attribute_key);
create index uc_group_attribute_fk_idx on public.uc_group_attribute (group_id);
alter table public.uc_group_attribute add constraint FKCFA740F998609D33 foreign key (group_id) references public.uc_group;
